//-------------------------------------------------------------------------------------------------+
// MapToImage.h
// Define MapToImage class that converts global map data to image
//-------------------------------------------------------------------------------------------------+

#ifndef __MAPTOIMAGE__
#define __MAPTOIMAGE__

#include "MRFCStub.h"
#include "AislGlobalPlanningStub.h"
#include "IIS2Stub.h"

#include "cv.h"
#include "highgui.h"


//-------------------------------------------------------------------------------------------------+
// n}f[^摜𐶐NX
//-------------------------------------------------------------------------------------------------+
class MapToImage{
private:
	int for_anime;
	double x_scale, y_scale, origin_x, origin_y;

public:
	IplImage *image;

	MapToImage(){ image = 0; for_anime = 0; x_scale = y_scale = 1.0; }
	MapToImage( const MapToImage& obj ){ image = 0; }
	~MapToImage(){ if( image ) cvReleaseImage( &image ); }

	void DrawMap( MRFC::TimedFloatAbsoluteOGMapData *mapdata, bool color_reverse=0, double scale=1.0 );
	void DrawMap( MRFC::TimedAbsoluteOGMapData *mapdata, bool color_reverse=0, double scale=1.0 );
	void DrawRobot( RTC::Pose2D pose );
	void DrawPoses( IIS::TimedPose2DSeq poses );
	void DrawPath( IIS::TimedPoseVel2DSeq path );
	void DrawPersons( TUT::TimedPersonsGlobalPosition persons );
	void DrawAreaInfo( TUT::TimedAreaInfo *areainfo );

private:
	void UpdateAnimation();
	void DrawFloatMap( IplImage *img, MRFC::TimedFloatAbsoluteOGMapData *mapdata, bool color_reverse );
	void DrawOctetMap( IplImage *img, MRFC::TimedAbsoluteOGMapData *mapdata, bool color_reverse );
	void Put( IplImage *img, int x, int y, int r, int g, int b );
	void Circle( IplImage *img, double x, double y, int radius, CvScalar color );
	void Segment( IplImage *img, double x, double y, double heading, double length, CvScalar color );
	void ConnectLine( IplImage *img, double x1, double y1, double x2, double y2, CvScalar color );
	int Convert( double x );
	int Convert( double y, int height );
};


#endif //__MAPTOIMAGE__
